{% include directory ~ '/templates/navigation/menu-new.html.twig' %}
{# {{ page.navigation }} #}
<main role="main" class="bg-blue-gradient">
  {{ page.breadcrumb }}
  <a id="main-content" tabindex="-1"></a>
  {# link is in html.html.twig #}

  <div class="container mt-5">
    <div class="px-md-3 px-lg-4 px-xl-5 px-xxl-6">
      <div class="row mt-5">
        <div class="col-md-6">
          <form class="form-border" id="form-redeem" action="{{ url('growhappy_mod.redeem-process') }}" method="POST">
            {% if reward.type == 'physical' %}
              <div class="d-flex justify-content-between">
                <h3 class="text-primary mb-2">Alamat penerima</h3>
                <button type="button" class="btn btn-link text-blue text-decoration-none" data-toggle="modal" data-target="#addressModal">Tambah Alamat</button>
              </div>
              <br>
              <div class="list-group overflow-hidden" id="list-tab" role="tablist">
                {% if addresses %}
                  {% for address in addresses %}
                    {% set active = '' %}
                    {% if address.id == addresses[0].id %}
                      {% set active = 'active' %}
                    {% endif %}
                    <a class="list-group-item list-group-item-action {{ active }}" id="{{ address.id }}" data-toggle="list" href="javascript:;" role="tab">
                      <h3 class="text-primary">{{ address.name }}</h3>
                      <p>{{ address.jalan }} - {{ address.kota }} - {{ address.provinsi }} - {{ address.kodepos }}</p>
                    </a>
                  {% endfor %}
                {% else %}
                  <p class="text-warning text-center mb-2">-- Alamat kosong --</p>
                {% endif %}
              </div>
              <br><br>
              <input type="hidden" name="key" value="address_id">
              <input type="hidden" name="value" id="address_id" value="{{ addresses[0].id }}">
              <script>
                var x = document.getElementsByClassName("list-group-item-action");
                for (i = 0; i < x.length; i++) {
                    x[i].onclick=function(){
                      $("#address_id").val(this.id);
                    }
                }
              </script>
            {% else %}
              {% for form in reward.forms %}
                {% if form.type == 'text' %}
                  <div class="d-flex justify-content-between">
                    <h3 class="text-primary mb-2">Silahkan masukan {{ form.label }} anda</h3>
                  </div>
                  <br>
                  <div class="form-group">
                      <input type="hidden" name="key" value="{{ form.key }}">
                      <input type="text" name="value" class="form-control rounded-pill border border-light mr-lg-5" placeholder="{{ form.label }}" {% if form.rules == 'required' %} required {% endif %}>
                  </div>
                {% elseif form.type == 'select' %}
                  <div class="d-flex justify-content-between">
                    <h3 class="text-primary font-weight-bold mb-2">Pilih {{ form.label }} berikut :</h3>
                  </div>
                  <br>
                  <input type="hidden" name="key" value="{{ form.key }}">
                  <select class="h4 icon-dropdown font-weight-bold border-0"  name="value" style="background: #10A6ED; padding: 10px; color: white; border-radius: 30px; outline: none;" {% if form.rules == 'required' %} required {% endif %}>
                    {% for option in form.options %}
                        <option value="{{ option.name }}" >{{ option.name }}</option>
                    {% endfor %}
                  </select>
                {% endif %}
              {% endfor %}
            {% endif %}
            <h3 class="text-primary mb-2">Rincian penukaran Happy Points</h3>
            <br>
            <ul class="list-group">
              <li class="list-group-item d-flex justify-content-between align-items-center">
                Jumlah Awal
                <span class="text-blue">{{ point }} Happy Points</span>
              </li>
              <li class="list-group-item d-flex justify-content-between align-items-center">
                Jumlah yang ditukar
                <span class="text-blue">{{ item.point }} Happy Points</span>
              </li>
              {% set total = point - item.point %}
              <li class="list-group-item d-flex justify-content-between align-items-center">
                Sisa Happy Points
                <span class="text-primary">{{ total }} Happy Points</span>
              </li>
              <li class="list-group-item d-flex justify-content-between align-items-center bg-primary text-white pb-0">
                <p>Dengan klik tombol TUKAR HAPPY POINTS, Happy Parents secara langsung telah menyetujui Syarat &amp; Ketentuan yang berlaku.</p>
              </li>
              <li class="list-group-item d-flex justify-content-between align-items-center bg-primary text-white">
                <div><small>Happy Points yang Ditukar</small><br>
                  <div class="rp">{{ item.point }}</div>
                </div>
                <a class="btn bg-white text-primary rounded-pill my-2 px-5 btn-cta text-uppercase border-0" data-toggle="modal" data-target="#redeemModal" id="btn-redeem">Tukar Happy Points</a>
              </li>
            </ul>
            <input type="hidden" name="reward" value="{{ item.code }}">
            <input type="hidden" name="i" value="{{ item.id }}">
            <input type="hidden" name="s" value="{{ reward.slug }}">
            <button type="submit" style="display: none;" id="btn-submit">Submit</button>
          </form>
        </div>
        <div class="col-md-6 mt-5 mt-lg-0 pl-lg-5">
          <h3 class="text-primary mb-2">Rewards yang dipilih</h3>
          <br>
          <div class="media bg-blue rounded-lg p-5">
            <img class="rounded-circle mr-4" height="100" width="100" src="{{ reward.thumbnail }}" alt="...">
            <div class="media-body">
              <h3 class="text-white mt-0">{{ item.name }}</h3>
              <div class="rp text-primary">{{ item.point }} Happy Points</div>
            </div>
          </div>
        </div>
      </div>
    </div>
  </div>
</main>

<!-- Modal Address -->
<div class="modal fade" id="addressModal" tabindex="-1" aria-labelledby="addressModalLabel" aria-hidden="true">
  <div class="modal-dialog">
    <div class="modal-content">
      <div class="modal-header p-lg-4">
        <h5 class="modal-title text-primary" id="addressModalLabel">Tambah Alamat</h5>
        <button type="button" class="btn btn-link text-blue text-decoration-none" data-dismiss="modal" aria-label="Close">
          Batal
        </button>
      </div>
      <div class="modal-body p-lg-4 text-primary">
        <form class="form-border" action="{{ url('<front>') }}address-process" method="POST">
            <input type="hidden" name="i" value="{{ item.id }}">
            <input type="hidden" name="s" value="{{ reward.slug }}">
          <div class="form-group">
            <input type="text" class="form-control rounded-pill border border-light" id="addr-name" name="address[name]" placeholder="Nama Penerima">
          </div>
          <div class="form-group">
            <select class="form-control rounded-pill border border-light" id="provinsi">
              <option selected>Provinsi</option>
              {% for prov in provinsi %}
                <option value="{{ prov.id }}">{{ prov.name }}</option>
              {% endfor %}
            </select>
            <input type="hidden" name="address[provinsi]" id="provinsi_value">
          </div>
          <div class="form-group">
            <select class="form-control rounded-pill border border-light" id="kabupaten">
              <option selected>Kota/Kabupaten</option>
            </select>
            <input type="hidden" name="address[kabupaten]" id="kabupaten_value">
          </div>
          <div class="form-group">
            <select class="form-control rounded-pill border border-light" id="kecamatan">
              <option selected>Kecamatan</option>
            </select>
            <input type="hidden" name="address[kecamatan]" id="kecamatan_value">
          </div>
          <div class="form-group">
            <select class="form-control rounded-pill border border-light" id="kelurahan">
              <option selected>Kelurahan/Desa</option>
            </select>
            <input type="hidden" name="address[kelurahan]" id="kelurahan_value">
          </div>
          <div class="form-group">
            <input type="text" class="form-control rounded-pill border border-light" id="kodepos" placeholder="Kode Pos" name="address[kodepos]">
          </div>
          <div class="form-group">
            <label for="message-text" class="col-form-label">Masukkan Alamat Lengkap*</label>
            <textarea class="form-control rounded-pill border border-light" id="message-text" name="address[jalan]"></textarea>
          </div>
          <div class="form-group">
            <label for="message-text" class="col-form-label">Keterangan (Patokan alamat)</label>
            <textarea class="form-control rounded-pill border border-light" id="message-text" name="address[notes]"></textarea>
          </div>
          <p>Mohon menuliskan alamat secara lengkap dan jelas. Termasuk RT/RW, nomor rumah (bila ada), kelurahan, kecamatan, serta detail lainnya yang diperlukan untuk mempermudah pengiriman paket oleh tim ekspedisi.</p>
          <button type="submit" class="btn btn-primary btn-block rounded-lg px-3 text-uppercase">Simpan Alamat</button>
        </form>
      </div>
    </div>
  </div>
</div>

<!-- Modal Redeem Confirm-->
<div class="modal fade" id="redeemModalConfirm" data-backdrop="static" data-keyboard="false" tabindex="-1" aria-labelledby="redeemModalConfirmLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered">
    <div class="modal-content overflow-hidden">
      <div class="modal-body bg-primary text-white text-center p-lg-4">
        <h3>Apakah Happy Parents yakin untuk menukarkan <span class="text-blue">{{ item.point }} Happy Points</span> ?</h3>
        <p>Dengan klik tombol YA, Happy Parents secara langsung telah menyetujui Syarat &amp; Ketentuan yang berlaku.</p>
        <div class="d-flex justify-content-between">
          <button type="button" class="btn btn-block bg-white text-blue rounded-lg px-3 mx-5 my-3" data-dismiss="modal" aria-label="Close" id="btn-no">Kembali</button>
          <button type="button" class="btn btn-block btn-blue rounded-lg px-3 mx-5 my-3" id="btn-yes">Ya</button>
        </div>
      </div>
    </div>
  </div>
</div>

<!-- Redeem Modal -->
<div class="modal fade" id="redeemModal" data-backdrop="static" data-keyboard="false" tabindex="-1" aria-labelledby="redeemModalLabel" aria-hidden="true">
  <div class="modal-dialog modal-dialog-centered">
    <div class="modal-content overflow-hidden">
      <div class="modal-body bg-primary text-white text-center p-lg-4">
        <button type="button" id="btn-close-modal" class="close float-right text-white" data-dismiss="modal" aria-label="Close">
          <span aria-hidden="true">&times;</span>
        </button>
        <img class="m-auto mb-4" src="{{ url('<front>') }}themes/growhappytheme/assets/images/icon-baloon.svg" alt="">
        <h2 id="message-header">Penukaran Happy Points Sedang diproses!</h2>
        <div id="message-body">Mohon Tunggu...</div>
        <a id="message-button" data-dismiss="modal" class="btn btn-block bg-white text-blue rounded-lg px-3" style="display: none;">Coba Lagi</a>
      </div>
    </div>
  </div>
</div>

<footer id="primary-footer">
  {% include directory ~ '/templates/includes/_footer_nestle.html.twig' %}
</footer>
<script src="https://code.jquery.com/jquery-3.5.1.min.js"></script>
<script src="https://js.pusher.com/7.0/pusher.min.js"></script>
<script type="text/javascript">
  $("#btn-redeem").click(function(){
    $("#btn-submit").click();
    // return false;
  });

  $("#form-redeem").submit(function(e) {
    e.preventDefault(); // avoid to execute the actual submit of the form.
    var form = $(this);
    var url = form.attr('action');
    var type = $(this).attr("method");

    var message_header_loading = "Penukaran Happy Points Kode Sedang diproses!";
    var message_header_fail = "Penukaran Happy Points Gagal";

    var message_body_loading = "<p>Mohon Tunggu...</p>";
    var message_body_fail = "<p>Terjadi kesalahan pada server</p>";

    var message_button_fail = "Coba Lagi";

    var message_button_fail_pprty = "Submit sekarang";

    var message_button_fail_flsh = "Lihat reward lain";

    // $("#redeemModalConfirm").modal('hide');
    $("#redeemModal").modal('show');

    $.ajax({
        type: type,
        url: url,
        data: form.serialize(),
        beforeSend: function() {
          // $("#btn-yes").prop('disabled', true);
          // $("#btn-no").prop('disabled', true);
          $("#btn-redeem").prop('disabled', true);
          $("#message-header").html(message_header_loading);
          $("#message-body").html(message_body_loading);
          $("#message-button").hide();
          $("#btn-close-modal").hide();
          console.log('Loading');
        },
        success: function(data)
        {
          console.log('json : '+data);
          var data = JSON.parse(data);
          var pusherFailed = false;
          var pusherProcessed = false;
          if(data.success){
            console.log('redeem success');
            console.log("pusher ready!");
            $.get("{{ url('growhappy_mod.pusher') }}", function(dataPusher, statusPusher){
              var dataPusher = JSON.parse(dataPusher);
              var pusher = new Pusher(dataPusher.key, {
                cluster: dataPusher.cluster,
                authEndpoint: "{{ url('growhappy_mod.pusher-auth') }}",
              });
              var channel = pusher.subscribe('private-member.{{ guestlogin.id }}');

              channel.bind('redemption.failed',
                function(dataRedeemFail) {
                  console.log('pusher failed : ');
                  console.log(dataRedeemFail);
                  pusherFailed = true;

                  message_body_fail = '<p>'+data.errors+'</p>';
                  $("#message-header").html(message_header_fail);
                  $("#message-body").html(message_body_fail);
                  $("#message-button").html(message_button_fail);
                  $("#message-button").show();
                  $("#message-button").attr("data-dismiss", "modal");
                  $("#message-button").removeAttr("href", "{{ url('<front>') }}profile");

                  $("#btn-close-modal").show();
                }
              );

              channel.bind('redemption.processed',
                function(dataRedeemSuccess) {
                  console.log('pusher success : ');
                  console.log(dataRedeemSuccess);
                  pusherProcessed = true;

                  $("#message-header").html("Penukaran Happy Points Berhasil!");
                  $("#message-body").html('<p>Selamat! Happy Parents berhasil menukar <span class="text-blue">{{ item.point }} Happy Points</span> dengan <span class="text-blue">{{ reward.name }}</span>. Untuk melihat status penukaran Happy Points, silakan cek Riwayat di Profil Happy Parents.</p>');

                  $("#message-button").html('Lihat Status');
                  $("#message-button").show();
                  $("#message-button").removeAttr("data-dismiss", "modal");
                  $("#message-button").attr("href", "{{ url('<front>') }}profile");

                  $("#btn-close-modal").show();
                }
              );
            });

            setTimeout(function() {
              console.log('timeout start');
              if(pusherFailed == false && pusherProcessed == false){
                console.log('if pusher timeout');
                $("#message-header").html(message_header_loading);
                $("#message-body").html("Proses ini lebih lama dari yg kami pekirakan, silakan refresh halaman ini kembali atau cek saldo anda");
                $("#message-button").show();
                $("#message-button").attr("href", "/profile");
                $("#message-button").html('Lihat Status');
              }
            }, 60000);
          }else{
            if (data.status == "not_yet_submit" || data.status == "not_submit") {

              console.log('redeem fail');
              message_body_fail = '<p>'+data.errors+'</p>';
              $("#message-header").html(message_header_fail);
              $("#message-body").html(message_body_fail);
              $("#message-button").html(message_button_fail_pprty);
              $("#message-button").show();
              $("#message-button").removeAttr("data-dismiss", "modal");
              $("#message-button").attr("href", "{{ url('<front>') }}profile");

            } else if (data.status == "not_eligible") {

              console.log('redeem fail');
              message_body_fail = '<p>'+data.errors+'</p>';
              $("#message-header").html(message_header_fail);
              $("#message-body").html(message_body_fail);
              $("#message-button").html(message_button_fail_flsh);
              $("#message-button").show();
              $("#message-button").removeAttr("data-dismiss", "modal");
              $("#message-button").attr("href", "{{ url('<front>') }}club");

            } else {

              console.log('redeem fail');
              message_body_fail = '<p>'+data.errors+'</p>';
              $("#message-header").html(message_header_fail);
              $("#message-body").html(message_body_fail);
              $("#message-button").html(message_button_fail);
              $("#message-button").show();
              $("#btn-close-modal").show();

            }

          }
          // $("#btn-yes").prop('disabled', false);
          // $("#btn-no").prop('disabled', false);
          $("#btn-redeem").prop('disabled', false);
        },
        error: function(xhr, status, error) {
            var error = eval("(" + xhr.responseText + ")");
            // console.log(error.message);
            $("#message-header").html(message_header_fail);
            $("#message-body").html('<p>'+error.message+'</p>');

            $("#message-button").html(message_button_fail);
            $("#message-button").show();
            $("#message-button").attr("data-dismiss", "modal");
            $("#message-button").removeAttr("href", "{{ url('<front>') }}profile");

            $("#btn-close-modal").show();
        }
    });
  });

  $('#provinsi').on('change', function() {
    var provinsi_id = this.value;
    var text = $(this).find("option:selected").text();
    var url = "{{ url('growhappy_mod.get-kabupaten') }}?provinsi_id="+provinsi_id;
    $.ajax({
       type: "GET",
       url: url,
       success: function(data)
        {
          $('#kabupaten').empty();
          $("#provinsi_value").val(text);

          var toAppend = '<option selected>Kota/Kabupaten</option>';
          $.each(JSON.parse(data), function(k,v){
            toAppend += '<option value='+v.id+'>'+v.name+'</option>';
          });

         $('#kabupaten').append(toAppend);
        }
    });
  });

  $('#kabupaten').on('change', function() {
    var kabupaten_id = this.value;
    var text = $(this).find("option:selected").text();
    var url = "{{ url('growhappy_mod.get-kecamatan') }}?kabupaten_id="+kabupaten_id;
    $.ajax({
       type: "GET",
       url: url,
       success: function(data)
        {
          $('#kecamatan').empty();
          $("#kabupaten_value").val(text);

          var toAppend = '<option selected>Kecamatan</option>';
          $.each(JSON.parse(data), function(k,v){
            toAppend += '<option value='+v.id+'>'+v.name+'</option>';
          });

         $('#kecamatan').append(toAppend);
        }
    });
  });

  $('#kecamatan').on('change', function() {
    var kecamatan_id = this.value;
    var text = $(this).find("option:selected").text();
    var url = "{{ url('growhappy_mod.get-kelurahan') }}?kecamatan_id="+kecamatan_id;
    $.ajax({
       type: "GET",
       url: url,
       success: function(data)
        {
          $('#kelurahan').empty();
          $("#kecamatan_value").val(text);

          var toAppend = '<option selected>Kelurahan/Desa</option>';
          $.each(JSON.parse(data), function(k,v){
            toAppend += '<option value='+v.id+'>'+v.name+'</option>';
          });

         $('#kelurahan').append(toAppend);
        }
    });
  });

  $('#kelurahan').on('change', function() {
    var kelurahan_id = this.value;
    var text = $(this).find("option:selected").text();
    var url = "{{ url('growhappy_mod.get-kodepos') }}?kelurahan_id="+kelurahan_id;
    $.ajax({
       type: "GET",
       url: url,
       success: function(data)
        {
          var data = JSON.parse(data);
          $("#kelurahan_value").val(text);
          $('#kodepos').val(data.kodepos);
        }
    });
  });
</script>
